
; List utilities.

(define (remq x l)
  (let ((probe (memq x l)))
    (if probe
	(let recur ((l l))
	  (if (eq? l probe)
	      (cdr l)
	      (cons (car l) (recur (cdr l)))))
	l)))
	    
(define (intersectq l1 l2)
  (cond ((null? l1) l1)
	((null? l2) l2)
	((memq (car l1) l2)
	 (cons (car l1) (intersectq (cdr l1) l2)))
	(else (intersectq (cdr l1) l2))))

(define (reduce cons nil list)
  (if (null? list)
      nil
      (cons (car list) (reduce cons nil (cdr list)))))

(define (intersect? l1 l2)
  (cond ((null? l1) #f)
        ((null? l2) #f)
        ((memq (car l1) l2))
        (else (intersect? (cdr l1) l2))))

(define (find-if pred l)
  (if (null? l)
      #f
      (if (pred (car l))
          (car l)
          (find-if pred (cdr l)))))

(define (last l)
  (car (last-pair l)))
(define (last-pair l)
  (if (pair? (cdr l))
      (last-pair (cdr l))
      l))

; Given (x y z), form (list (proc z x) (proc x y) (proc y z)).

(define (map-cyclically proc l)
  (map proc (cons (last l) l) l))


